import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

import org.w3c.dom.*;

public class XMLJoonis extends Frame implements ActionListener, 
   MouseListener, MouseMotionListener{
  
  Button nupp = new Button("Lae");
  Button salvesta=new Button("Salvesta");
  Button tryki=new Button("Trki");
  Button kustuta=new Button("Kustuta");
  String failinimi="joonistusandmed.xml";
  Document d;
  Node juur, joon;
 
  public XMLJoonis(){
      setLayout(new FlowLayout());
      add(nupp);    add(salvesta);
      add(tryki);   add(kustuta);
      nupp.addActionListener(this);
      salvesta.addActionListener(this);
      tryki.addActionListener(this);
      kustuta.addActionListener(this);
      addMouseListener(this);
      addMouseMotionListener(this);
      addWindowListener(new WindowAdapter(){
        public void windowClosing(WindowEvent evt){          
         System.exit(0);
        }
      });
      alusta();
      setSize(400,300);
      setVisible(true);  
  }
  
  public void actionPerformed(ActionEvent e){
    if(e.getSource()==nupp){
     try{
         d=DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(failinimi);
         juur=(Element)d.getFirstChild();
         repaint();
     } catch(Exception viga){System.out.println("Probleem lugemisel: "+viga);   }
    }
    if(e.getSource()==salvesta){
      try{
             Transformer t=TransformerFactory.newInstance().newTransformer();
             FileOutputStream valja=new FileOutputStream(failinimi);
             t.transform(new DOMSource(d), new StreamResult(valja));
             valja.close();
      } catch(Exception viga){ viga.printStackTrace();   }
    } 
    if(e.getSource()==tryki){System.out.println(d.getFirstChild());}
    if(e.getSource()==kustuta){alusta();}
  }
  
  
  public void paint(Graphics g){
    NodeList jooned=d.getFirstChild().getChildNodes();
    for(int i=0; i<jooned.getLength(); i++){
      NodeList punktid=jooned.item(i).getChildNodes();
      for(int j=1; j<punktid.getLength(); j++){
        Node p1=punktid.item(j-1);
        Node p2=punktid.item(j);
        int x1=Integer.parseInt(((Element)p1).getElementsByTagName("x").item(0).getFirstChild().getNodeValue());
        int y1=Integer.parseInt(p1.getFirstChild().getNextSibling().getFirstChild().getNodeValue());
        int x2=Integer.parseInt(p2.getFirstChild().getFirstChild().getNodeValue());
        int y2=Integer.parseInt(p2.getFirstChild().getNextSibling().getFirstChild().getNodeValue());
        g.drawLine(x1, y1, x2, y2);
      }
    }
  }
  
  
  
  public void mousePressed(MouseEvent e) {
    joon=d.createElement("joon");
    juur.appendChild(joon);
    lisaPunkt(e.getX(), e.getY());    
  }
  
  public void mouseDragged(MouseEvent e){
     lisaPunkt(e.getX(), e.getY());
  }

  void lisaPunkt(int x, int y){
    Element punkt=d.createElement("punkt");
    Element px=d.createElement("x");
    px.appendChild(d.createTextNode(x+""));
    punkt.appendChild(px);
    Element py=d.createElement("y");
    py.appendChild(d.createTextNode(y+""));
    punkt.appendChild(py);
    joon.appendChild(punkt);  
  }

  public void alusta(){
      try{
         d=DocumentBuilderFactory.newInstance().newDocumentBuilder().newDocument();
         juur=d.createElement("koordinaadid");
         d.appendChild(juur);
         repaint();
      } catch(Exception viga){System.out.println("Viga dokumendi loomisel: "+viga);}           
  }

  public void mouseClicked(MouseEvent e) { }
  public void mouseReleased(MouseEvent e) { repaint(); }
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mouseMoved(MouseEvent e){}
  
  
  public static void main(String argumendid[]) throws Exception{
    new XMLJoonis();
  }
}